#include <windows.h>
#include <tchar.h>
#include <wininet.h>
#include "inetinfo.h"

#define WEB_SITE _T( "www.amazon.com" )
#define BOOK_URL _T( "/exec/obidos/ASIN/087930605X" )
#define PATTERN  "Amazon.com Sales Rank:"
#define BUF_SIZE (64 * 1024)

BOOL findSalesRank( HWND hwnd, char *pszData ) {
    BOOL  bOK = FALSE;
    LPSTR psz = strstr( pszData, PATTERN );
    if ( 0 != psz ) {
        psz += strlen( PATTERN );
        while ( 0 != *psz && !isdigit( *psz ) ) {
            ++psz;
        }
        bOK = 0 != *psz;
        if ( bOK ) {
            LPSTR pszEnd = psz;
            while ( 0 != *pszEnd && 
                (isdigit( *pszEnd ) || _T( ',' ) == *pszEnd) )
            {
                ++pszEnd;
            }
            *pszEnd = 0;
#ifdef _UNICODE
            {
                TCHAR szRank[ 100 ] = { 0 };
                MultiByteToWideChar( CP_ACP, 0, psz, -1, szRank, 
                    sizeof( szRank ) / sizeof( TCHAR ) );
                SetDlgItemText( hwnd, IDC_SALESRANK, szRank );
            }
#else
            SetDlgItemText( hwnd, IDC_SALESRANK, psz );
#endif
        }
    }
    return bOK;
}

BOOL receive( HWND hwnd, HINTERNET hConnection ) {
    char  szData[ BUF_SIZE + 1 ] = { 0 };
    DWORD dwRead   = 0;
    DWORD dwOffset = 0;
    for ( dwOffset = 0; dwOffset < BUF_SIZE; dwOffset += dwRead ) {
        const BOOL bOK = InternetReadFile( hConnection, 
            szData + dwOffset, BUF_SIZE - dwOffset, &dwRead );
        if ( !bOK || !isRunning() || 0 == dwRead ) {
            break; //*** LOOP EXIT POINT
        }
    }
    return findSalesRank( hwnd, szData );
}

BOOL request( HWND hwnd, HINTERNET hConnect ) {
    BOOL bOK = FALSE;
    HINTERNET hRequest = HttpOpenRequest( 
        hConnect, _T( "GET" ), BOOK_URL, 0, 0, 0,
        INTERNET_FLAG_KEEP_CONNECTION | INTERNET_FLAG_RESYNCHRONIZE,
        0 );
    if ( 0 != hRequest ) {
        setStatus( hwnd, _T( "Sending query" ) ); 
        bOK = HttpSendRequest( hRequest, 0, 0, 0, 0 );
        if ( bOK && isRunning() ) {
            setStatus( hwnd, _T( "Receiving data" ) );
            bOK = receive( hwnd, hRequest );
        }
        InternetCloseHandle( hRequest );
    }
    return bOK;
}

BOOL connection( HWND hwnd, HINTERNET hInternet ) {
    BOOL bOK = FALSE;
    HINTERNET hConnect = InternetConnect( hInternet, WEB_SITE, 
        INTERNET_INVALID_PORT_NUMBER, 0,
        0, INTERNET_SERVICE_HTTP,0,0 );
    if ( 0 != hConnect ) {
        bOK = request( hwnd, hConnect );
        InternetCloseHandle( hConnect  );
    }
    return bOK;
}

BOOL download( HWND hwnd ) {
    BOOL bOK = FALSE;
    HINTERNET hInternet = 0;
    hInternet = InternetOpen( 
        APP_NAME, INTERNET_OPEN_TYPE_PRECONFIG, 0, 0, 0 );
    if ( 0 != hInternet ) {
        bOK = connection( hwnd, hInternet );
        InternetCloseHandle( hInternet );
    }
    return bOK;
}

/* end of file */
