#include <windows.h>
#include <windowsx.h>
#include <tchar.h>
#include "inetinfo.h"

static HFONT s_hfontBig = 0;

void makeTopMost( HWND hwnd ) {
    const DWORD dwExStyle = GetWindowLong( hwnd, GWL_EXSTYLE );
    SetWindowLong( hwnd, GWL_EXSTYLE, dwExStyle | WS_EX_TOPMOST );
}

void disableButton( HWND hwnd ) {
    Button_SetStyle( hwnd, BS_PUSHBUTTON, TRUE );
    EnableWindow( hwnd, FALSE );
}

void onInitDialog( HWND hwnd ) {
    HWND hwndSalesRank = GetDlgItem( hwnd, IDC_SALESRANK );
    HFONT hfont = GetWindowFont( hwnd );
    LOGFONT lf = { 0 };
    GetObject( hfont, sizeof lf, &lf );
    lf.lfWeight = FW_HEAVY;
    lf.lfWidth  = MulDiv( lf.lfWidth , 7, 4 );
    lf.lfHeight = MulDiv( lf.lfHeight, 7, 4 );
    _tcscpy( lf.lfFaceName, _T( "Comic Sans MS" ) );
    s_hfontBig = CreateFontIndirect( &lf );
    SetWindowFont( hwndSalesRank, s_hfontBig, TRUE );

    makeTopMost( hwnd );
    if ( !startDownload( hwnd ) ) {
        EndDialog( hwnd, IDCANCEL );
    }
}

void onClose( HWND hwnd ) {
    setStatus( hwnd, _T( "Closing..." ) );
    disableButton( GetDlgItem( hwnd, IDC_REFRESH ) );
    disableButton( GetDlgItem( hwnd, IDC_EXIT    ) );
    stopDownload();
    EndDialog( hwnd, IDCANCEL );
}

BOOL CALLBACK mainDlgProc(
    HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam )
{
    switch ( msg ) {
    case WM_INITDIALOG:
        onInitDialog( hwnd );
        return TRUE;

    case WM_CLOSE:
        onClose( hwnd );
        return TRUE;

    case WM_COMMAND:
        if ( BN_CLICKED == GET_WM_COMMAND_CMD ( wParam, lParam ) ) {
            const int id = GET_WM_COMMAND_ID( wParam, lParam );
            if ( IDC_REFRESH == id ) {
                update();
            } else if ( IDCANCEL == id || IDC_EXIT == id ) {
                onClose( hwnd );
            }
        }
        return TRUE;
    }

    return FALSE;
}

int APIENTRY _tWinMain( HINSTANCE hinst,
    HINSTANCE hinstPrev, LPTSTR lpszCmdLine, int nCmdShow )
{
    DialogBox( hinst, _T( "MainDlg" ), 0, mainDlgProc );
    DeleteFont( s_hfontBig );
}

/* end of file */
